#include <bits/stdc++.h>
#define ll long long

using namespace std;


bool prolaz[1000010];
int voda[1000010];

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

    int n,h;
    cin>>h>>n;

    for(int i=0;i<n;i++)
        voda[i]=1;

    for(int j=1;j<=h;j++)
    {
        for(int i=0;i<n;i++)
            cin>>prolaz[i];

        bool stena=false;
        int levi=-1;
        int suma=0;
        for(int i=0;i<n;i++)
        {
            if(prolaz[i] && stena)
            {
                if(levi!=-1)
                {
                    voda[levi]+=suma/2;
                    voda[i]+=suma/2;
                    if(suma%2==1)
                        if(j%2==1) voda[levi]++;
                        else voda[i]++;
                }
                else
                    voda[i]+=suma;

                stena=false;
                suma=0;
            }
            if(!prolaz[i])
            {
                suma+=voda[i];
                voda[i]=0;
                if(!stena)
                    levi=i-1, stena=true;
            }
        }
        if(stena)
            voda[levi]+=suma;

    }
    for(int i=0;i<n;i++)
        cout<<voda[i]<<" ";
	return 0;
}